#!/usr/local/python/2.4.2/bin/python
#Rene Warren April 11th/2006
#
#Wrapper for the THOR web. app.
#-Launches the THOR java on specified server
#-Mails the user

import sys
import os
import commands
import time
import datetime
import re

import smtplib
import MimeWriter
import base64
import StringIO
import string
import quopri


########################################################
#LAUNCH THOR 
########################################################


VECTOR_FILE = "/projects/02/rwarren/tmp/THOR/vector.seq"
THOR_EXEC = "/usr/local/java/jre1.5.0_05/bin/java -cp /projects/02/rwarren/THOR_web/OneNodeAssembly THOR.Assemble"
SERVER = "apollo" 
SHELLSCRIPT = sys.argv[4] + sys.argv[6] + ".sh"
FROM_ADDR = ' "THOR" <thor@bcgsc.ca>'
TO_ADDR = [sys.argv[5],FROM_ADDR]
#TO_ADDR = [sys.argv[5],"rwarren@bcgsc.ca"]
#TO_ADDR = sys.argv[5] 
THORMAIL = "/projects/02/rwarren/THOR_web/thor_email.py"

####make shell script
#cmd4oscar = "#! /bin/sh\n\n#$ -S /bin/sh\n\n" + THOR_EXEC + " " + sys.argv[1] + " " + VECTOR_FILE + " " + sys.argv[2] + " " + sys.argv[3] + " " + sys.argv[4] + " > /dev/null 2> /dev/null;" + THORMAIL + " " + sys.argv[4] + " " + sys.argv[5] + " " + sys.argv[6] + " " + sys.argv[7] + ";rm -rf " + sys.argv[4]

#cmd4oscar = "#! /bin/sh\n\n#$ -S /bin/sh\n\n" + THOR_EXEC + " " + sys.argv[1] + " " + VECTOR_FILE + " " + sys.argv[2] + " " + sys.argv[3] + " " + sys.argv[4] + " > /dev/null 2> /dev/null;" + THORMAIL + " " + sys.argv[4] + " " + sys.argv[5] + " " + sys.argv[6] + " " + sys.argv[7]

#cmd4oscar = "#! /bin/sh\n\n#$ -S /bin/sh\n#$ -M " + sys.argv[5] + "\n#$ -M thor@bcgsc.ca\n#$ -m a\n#$ -l h_rt=4:0:0\n\n" + THOR_EXEC + " " + sys.argv[1] + " " + VECTOR_FILE + " " + sys.argv[2] + " " + sys.argv[3] + " " + sys.argv[4] + " > /dev/null 2> /dev/null;" + THORMAIL + " " + sys.argv[4] + " " + sys.argv[5] + " " + sys.argv[6] + " " + sys.argv[7]

cmd4oscar = "#! /bin/sh\n\n#$ -S /bin/sh\n#$ -M " + sys.argv[5] + "\n#$ -m bae\n#$ -l h_rt=4:0:0\n\n" + THOR_EXEC + " " + sys.argv[1] + " " + VECTOR_FILE + " " + sys.argv[2] + " " + sys.argv[3] + " " + sys.argv[4] + " > /dev/null 2> /dev/null;" + THORMAIL + " " + sys.argv[4] + " " + sys.argv[5] + " " + sys.argv[6] + " " + sys.argv[7] + ";rm -rf " + sys.argv[4] + "phrap;rm -rf " + sys.argv[4] + "blast"



file_obj = open(SHELLSCRIPT, 'w')
file_obj.write(cmd4oscar)
file_obj.close()


cmd = "ssh " + SERVER + " 'export SGE_ROOT=/opt/sge;cd " + sys.argv[4] + " ;/opt/sge/bin/lx26-amd64/qsub -N webTHOR" + " " + SHELLSCRIPT + "'"


print "Running:\n %s\n" % cmd

(status, out) = commands.getstatusoutput(cmd)


########################################################
#EMAIL MAIN CONTACT IF LAUNCHING JOB ON OSCAR FAILED 
########################################################


#### Read the output, email the user with the results

message = StringIO.StringIO()
writer = MimeWriter.MimeWriter(message)
writer.addheader('MIME-Version', '1.0')
writer.addheader('Subject', "Your THOR job id#%s" % (sys.argv[6]))
writer.addheader('To', sys.argv[5])
writer.addheader('From', FROM_ADDR)

underscore_regex = re.compile('_')                  ### underscore
animal_name = underscore_regex.sub(' ',sys.argv[7]) ### replace underscore by space


# get ready to send attachment
writer.startmultipartbody('mixed')

# start off with a text/plain part
part = writer.nextpart()
body = part.startbody('text/plain')

body.write("Your THOR job id#%s ( Assembly in %s) " % (sys.argv[6],animal_name))


if status != 0:

   body.write("failed to launch properly on the GSC-THOR server.\n\n\nError code: %s\nCommand: %s\nDetails: %s.\n\n" % (status,cmd,out))
   body.write("We apologize for the inconvenience,\n")

else:

   body.write("was launched properly on the GSC-THOR server.  You will receive an email when the run is done.\n\n")
   body.write("Typical execution times are between 5 minutes and 4 hours depending on organism coverage, query length and server load. If you have any questions, concerns or comments, please contact thor@bcgsc.ca\n\n")



body.write("-the THOR team")


# finish off
writer.lastpart()

# send the mail
smtp = smtplib.SMTP('mail.bcgsc.ca', 25)
smtp.sendmail(FROM_ADDR, TO_ADDR, message.getvalue() )
smtp.quit()








